<?php

namespace Drupal\spatialfields\Plugin\Field\FieldType;

use Drupal\Core\Field\FieldItemBase;
use Drupal\Core\Field\FieldStorageDefinitionInterface;
use Drupal\Core\TypedData\DataDefinition;

/**
 * Plugin implementation of the 'spatialfields line' field type.
 *
 * @FieldType(
 *   id = "spatialfields_line",
 *   label = @Translation("Line"),
 *   module = "spatialfields",
 *   category = @Translation("Spatial"),
 *   description = @Translation("Creates line field"),
 *   default_widget = "spatialwidget",
 *   default_formatter = "spatialformatter"
 * )
 */


class SpatialFieldsLine extends FieldItemBase {
  /**
  * {@inheritdoc}
  */
  public static function schema(FieldStorageDefinitionInterface $field_definition) {
    return array(
      // columns contains the values that the field will store
      'columns' => array(
        // List the values that the field will save. This
        // field will only save a single value, 'value'
        'value' => array(
          'type' => 'text',
        ),
      ),
    );
  }
  
  /**
  * {@inheritdoc}
  */
  public static function propertyDefinitions(FieldStorageDefinitionInterface $field_definition) {
    $properties = [];
    $properties['value'] = DataDefinition::create('string');
    return $properties;
  }
  
  /**
  * {@inheritdoc}
  */
  public function isEmpty() {
    $value = $this->get('value')->getValue();
    return $value === NULL || $value === '';
  }
}